function varargout = GUI(varargin)
% GUI M-file for GUI.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI

% Last Modified by GUIDE v2.5 25-Aug-2011 17:22:51

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GUI is made visible.
function GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI (see VARARGIN)

% Choose default command line output for GUI
handles.output = hObject;
clc
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
load joint_path.mat
Num_frames =1;
save(strcat(strcat(strcat(path_data,'temp'),joint),'Num_frames.mat'),'Num_frames');

% save Num_frames.mat Num_frames

flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames')
% save flag_frames.mat flag_frames
Generation

guidata(hObject, handles);

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
[FileName,PathName] = uigetfile('*.mat','Select the Mat-file containing a hologram or a video of holograms');
guidata(hObject, handles);

if  (FileName==0) 
   'Please select a file to load the hologram'
   errordlg('Task cancelled','Error');
else 
    [pathstr, name, ext] = fileparts(FileName);
    if  (strcmp('.fig',ext)==1) 
        uiopen('FIGURE')

    elseif  (strcmp('.mat',ext)==1) 
        c=struct2cell(load(FileName));
        holo=c{1,1};
        for i=1:size(holo,3)       
            figure(1000);imshow(holo(:,:,i),[]);title(sprintf('Selected hologram number %g of %g',i,size(holo,3)));axis on;colorbar;pause; 
        end
        
    else
        'Please select a .Mat or a .Fig file to load a hologram'
        errordlg('Please select a .Mat or a .Fig file to load a hologram or a video of holograms','Error');
    end
end



% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames')
% save flag_frames.mat flag_frames
for_Qmap
guidata(hObject, handles);


function pushbutton4_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
[FileName,PathName] = uigetfile('*.mat','Select the Mat-file containing the particles coordinates');

if  (FileName==0) 
%    'Please select the .Mat file to load the coordinates of particles'
   errordlg('Task cancelled','Error');
else 
    [pathstr, name, ext] = fileparts(FileName);
    if  (strcmp('.mat',ext)==0) 
        'Please select the .Mat file to load the coordinates of particles'
        errordlg('Please select the .Mat file to load the coordinates of particles','Error');

    else 
        c=struct2cell(load(FileName));
        particles=c{1,1};
        if size(particles,3)>1
            particle(:,:)=particles(:,:,1);
        else
            particle=particles;
        end
        Num_frames=size(particles,3);
        save(strcat(strcat(strcat(path_data,'temp'),joint),'Num_frames_view.mat'),'Num_frames');
        set(handles.uitable1,'data',particle);
        set(handles.text15,'String',sprintf('Particles for the frame Number %g',1));
        
        save(strcat(path_data,'particles_view.mat'),'particles');
        flag_frames=1;
        save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
    end
end
guidata(hObject, handles);

function popupmenu1_Callback(hObject, eventdata, handles)


function popupmenu1_CreateFcn(hObject, eventdata, handles)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
[FileName,PathName] = uigetfile('*.mat','Select the Mat-file containing the hologram or the video of holograms');

if  (FileName==0) 
%    'Please select the .Mat file to load the hologram'
   errordlg('Task cancelled','Error');
else 
    [pathstr, name, ext] = fileparts(FileName);
    if  (strcmp('.mat',ext)==0) 
        'Please select the .Mat file to load the hologram'
        errordlg('Please select the .Mat file to load the hologram or the video of holograms','Error');

    else 
        IA_name=FileName;
        IA_path=PathName;
        
        save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name.mat'),'IA_name');

%         save IA_name.mat IA_name
        save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path.mat'),'IA_path');

%         save IA_path.mat IA_path
        Inverse_approach_info
    end
end
guidata(hObject, handles);

function pushbutton6_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
Frames_of_video
guidata(hObject, handles);

function pushbutton8_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
For_3D_visual

guidata(hObject, handles);

function pushbutton10_Callback(hObject, eventdata, handles)
close GUI
return

function pushbutton11_Callback(hObject, eventdata, handles)
[FileName,PathName] = uigetfile('*.*','Please select one of your raw images');
load path_data.mat
load joint_path.mat
if  (FileName==0) 
%    'Please select the .Mat file to load the hologram'
   errordlg('Task cancelled','Error');
else 
    [pathstr, name, ext] = fileparts(FileName);
    if  (((strcmp('.tif',ext)==0) && ((strcmp('.tiff',ext)==0) && (strcmp('.png',ext)==0))) && ((strcmp('.jpg',ext)==0) && (strcmp('.jpeg',ext)==0)) )
%         'Please select the .Mat file to load the hologram'
        errordlg('This GUI support only images with formats tif,tiff,png,jpg,jpeg.','Error');

    else 
        IA_name_manual=FileName;
        IA_path_manual=PathName;
        
        
        Ssearch=strcat(strcat(PathName,'*'),ext);

        
        f=dir(Ssearch);
        f=struct2cell(f);
        Wait_Anounce
        names=f(1,:); 
        save(strcat(strcat(strcat(path_data,'temp'),joint),'names.mat'),'names');

        
        x=Remove_BG(names,PathName);
        close Wait_Anounce
    end
end


function pushbutton12_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat

I=struct2cell(load(strcat(path_data,'I0_video_manual.mat')));
I=I{1,1};
figure;imshow(I,[]);title('The background removed from your holograms');axis on;colorbar;pause;

names=struct2cell(load(strcat(strcat(strcat(path_data,'temp'),joint),'names.mat')));
names=names{1,1};

'Loading the Video ...'
hol=struct2cell(load(strcat(path_data,'hologram_video_manual.mat')));
hol=hol{1,1};
guidata(hObject, handles);
for i=1:size(hol,3)
    figure(1000);imshow(hol(:,:,i),[]);title(sprintf('The %g -th hologram of your video - %s',i,char(names(1,i))));axis on;colorbar;pause;
end




function pushbutton13_Callback(hObject, eventdata, handles)

load path_data.mat
load joint_path.mat
Num_frames=struct2cell(load(strcat(strcat(strcat(path_data,'temp'),joint),'Num_frames_view.mat')));
Num_frames=Num_frames{1,1};
% load Num_frames.mat


flag_frames=struct2cell(load(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat')));
flag_frames=flag_frames{1,1};
% load flag_frames.mat


if (flag_frames < Num_frames)
  flag_frames=flag_frames+1;
  
  save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');

  particle=struct2cell(load(strcat(path_data,'particles_view.mat')));
  particle=particle{1,1};
  particle=particle(:,:,flag_frames);
  set(handles.uitable1,'data',particle);
  set(handles.text15,'String',sprintf('Particles for the frame Number %g',flag_frames));
  guidata(hObject, handles);
else
    errordlg('Exceeding the number of frames','Error');
end


